/*
 *  TINIT.h
 *  Tombstone Demo
 *
 *  Created by EdzUp on 25/06/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */

#if defined( __APPLE__ )					//Apple platform uses OpenGL ES
	#if TARGET_OS_IPHONE || TARGET_OS_SIMULATOR
		#import <UIKit/UIKit.h>
		#import <OpenGLES/ES1/gl.h>
		#import "TombstoneiPhoneFunctions.h"
	#else
		#import <OpenGL/gl.h>
		#import <OpenGL/glu.h>
		#import <GLUT/GLUT.h>
		#import "TombstoneOSXFunctions.h"
	#endif
#endif

#if defined( __LINUX__ )
	#include <GL/glut.h>    // Header File For The GLUT Library
	#include <GL/gl.h>	// Header File For The OpenGL32 Library
	#include <GL/glu.h>	// Header File For The GLu32 Library
	#include <unistd.h>     // Header File For sleeping.
	#import "TombstoneLinuxFunctions.h"		//all linux declarations for the entire engine
#endif

#if defined( __WINDOWS__ )
	#include <gl\gl.h>			// Header File For The OpenGL32 Library
	#include <gl\glu.h>			// Header File For The GLu32 Library
	#include <gl\glaux.h>		// Header File For The Glaux Library	#import <windows.h>						//on windows platform import the Windows headers
	#import "TombstoneWindowsFunctions.h"	//windows functions
#endif

int OpenGLWindow;
#if !defined( __WINDOWS__ )
//WINDOWS cannot use this InitGL its called in the TombstoneWindows system
void InitGL( int SEargc, char* SEargv[] ) {
	//initialise OpenGL on Apple OSX, Windows and Linux
	cout << "OpenGL InitGL Called..." << endl;
	#if defined( __LINUX__ ) || defined( __APPLE__ )
		#if !TARGET_OS_IPHONE && !TARGET_OS_SIMULATOR
			//there is no InitGL call in Apple iPhone as EAGLView sorts that out
			glutInit( &SEargc, SEargv );
			#if defined( __APPLE__ )
				glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );
			#endif
			#if defined( __LINUX__ )
				glutInitDisplayMode( GLUT_RGBA | GLUT_DOUBLE | GLUT_ALPHA | GLUT_DEPTH );
			#endif
			#if defined( __WINDOWS__ )
				glutInitDisplayMode( GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA );
			#endif
			glutInitWindowSize ( TombstoneWidth, TombstoneHeight );
			glutInitWindowPosition ( 0, 0 );
			OpenGLWindow = glutCreateWindow ( TombstoneWindowTitle.c_str() );
			if ( TombstoneFullScreen == TRUE ) glutFullScreen();
	/*
	glEnable(GL_TEXTURE_2D);						// Enable Texture Mapping ( NEW )
			glShadeModel(GL_SMOOTH);						// Enable Smooth Shading
			glClearColor(0.0f, 0.0f, 0.0f, 0.5f);					// Black Background
			glClearDepth(1.0f);							// Depth Buffer Setup
			glEnable(GL_DEPTH_TEST);						// Enables Depth Testing
			glDepthFunc(GL_LEQUAL);							// The Type Of Depth Testing To Do
			glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);*/
		#endif
	#endif
}
#endif
