/*
 *  TombstoneCompatibility.h
 *  Tombstone Demo
 *
 *  Created by EdzUp on 03/06/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */

union endunion {
	long val;              // float view
	unsigned char bytes[ 0 ];
};

#ifndef WORD
typedef unsigned int WORD;
#endif
#ifndef BYTE
typedef unsigned char BYTE;
#endif

#if defined( __APPLE__ )
	//Apple platform defines
	#if TARGET_OS_IPHONE
		#define TargetPlatform "IPhone"
	#elif TARGET_IPHONE_SIMULATOR
		#define TargetPlatform "IPhone Simulator"
	#elif TARGET_OS_EMBEDDED
		#define TargetPlatform "Embedded OS"
	#endif
#else
	//everything else
	#if defined( __WINDOWS__ )
		#define TargetPlatform "Windows"
	#elif defined( __LINUX__ )
		#define TargetPlatform "Linux"
	#else
	     #define TargetPlatform "Unknown"
	#endif
#endif

#if TARGET_OS_IPHONE || TARGET_OS_SIMULATOR
	//Apple stuff here
#else
	//Objective C stuffs for apps that done have the stuff
	typedef float CGFloat;    // 32-bit
	typedef unsigned long NSUInteger;

    struct CGSize {
		CGFloat width;
		CGFloat height;
	};
//	static typedef struct CGSize CGSize;

	typedef struct CGPoint {
		CGFloat x;
		CGFloat y;
	};
//	static typedef struct CGPoint CGPoint;

	typedef struct CGRect {
		CGPoint origin;
		CGSize size;
	};
//	static typedef struct CGRect CGRect;
#endif

void endianess( void ) {
	//check endianess
	endunion endian;

	//short temp = 0x1234;
	//char* tempChar = (char*)&temp;
	
	//You will either get tempChar to be 0x12 or 0x34, from which you will know the endianness.
	endian.val = 15;
	if ( endian.bytes[ 0 ] == 15 ) {
		printf( "Little endianess\n" );
	} else {
		printf( "Big endianess\n" );
	}
}
