/*
 *  TombstoneConversion.h
 *  TombstoneDemoOSX
 *
 *  Created by EdzUp on 13/01/2011.
 *  Copyright 2011 Graveyard Dogs. All rights reserved.
 *
 */
#include <cstring>
using std::memcpy;

union convert_float32 {
	float f;              // float view
	unsigned char bytes[ 0 ];
};

long convertBytesToLong( const unsigned char* buffer ) {
	unsigned long int anotherLongInt;

	anotherLongInt = ( (buffer[0] << 24) 
					  + (buffer[1] << 16) 
					  + (buffer[2] << 8) 
					  + (buffer[3] ) );
	
	return( anotherLongInt );
}

int test( float val ) {
	convert_float32 a, b;
	a.f = val;

	for (size_t i = 0; i < sizeof( convert_float32 ); ++i)
	{
		std::cout << "byte " << i << ": "
		<< (unsigned int)(a.bytes[ i ])
		<< std::endl;
	
		b.bytes[ i ] = a.bytes[ i ];
	}
	std::cout << b.f << std::endl;
	
	return 0;
}

float convertBytesToFloat(unsigned char i[4] ) {
	convert_float32 val;
#if !defined( __APPLE__ )
	for (int j=0; j<4; j++) 
		val.bytes[ j ] = i[ j ];
#else
	val.bytes[ 0 ] = i[ 3 ];
	val.bytes[ 1 ] = i[ 2 ];
	val.bytes[ 2 ] = i[ 1 ];
	val.bytes[ 3 ] = i[ 0 ];
#endif
	return val.f;
}