/*
 *  TombstoneEngine.h
 *
 *  Created by EdzUp on 11/03/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */
#if defined( __APPLE__ )					//Apple platform uses OpenGL ES
#if TARGET_OS_IPHONE || TARGET_OS_SIMULATOR
#import <UIKit/UIKit.h>
#import <OpenGLES/ES1/gl.h>
#import "TombstoneiPhoneFunctions.h"
#else
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>
#import <GLUT/GLUT.h>
#import "TombstoneOSXFunctions.h"
#endif
#endif

#if defined( __LINUX__ )
#include <GL/glut.h>    // Header File For The GLUT Library 
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#include <unistd.h>     // Header File For sleeping.
#import "TombstoneLinuxFunctions.h"		//all linux declarations for the entire engine
#endif

#if defined( __WINDOWS__ )
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library#import <windows.h>						//on windows platform import the Windows headers
#import "TombstoneWindowsFunctions.h"	//windows functions
#endif

#include <fstream>
#include <iostream>
#include <string>
#include <list>
#include <stdio.h>
#include <time.h>		
#import "TINIT.h"							//required for initialisation of OpenGL engine
#import "TRegistry.h"
#import "TEntity.h"
#import "TText.h"
#import "TCamera.h"					//Tombstone camera system
#import "TLight.h"				//Tombstone lighting system
#import "TInput.h"
#import "TText.h"
#import "TombstoneRandomSystem.h"
#import "TombstoneCompatibility.h"
#import "TombstoneStringFunctions.h"
#import "TombstoneGlu.h"
#import "TombstoneVariables.h"
#import "TombstoneDebug.h"

using namespace std;

extern double mouseXPosition;
extern double mouseYPosition;

class TombstoneClass : public cameraClass, public TLight, public TInputClass {						//MAIN ENGINE CLASS
private:
	int			gLastName;
	char*		machineID;
	long		machineOS;
		
public:
	gluClass	TombstoneGlu;
	GLfloat		MaskRed;
	GLfloat		MaskBlue;
	GLfloat		MaskGreen;
	GLfloat		MaskAlpha;
	GLfloat		ClsRed;
	GLfloat		ClsBlue;
	GLfloat		ClsGreen;
	GLfloat		ClsAlpha;
	TCamera		firstCamera;
	TDebug		Debug;
	short		MaskActive;
	int			SetupCounter;
	
	/*
	 
	 -(void)setupView:(GLView*)view
	 {
	 GLfloat size; 
	 const GLfloat zNear = 0.1, 
	 zFar = 1000.0, 
	 fieldOfView = 60.0;
	 size = zNear * tanf(DEGREES_TO_RADIANS(fieldOfView) / 2.0); 
	 CGRect rect = self.view.bounds; 
	 glMatrixMode(GL_PROJECTION);
	 glEnable(GL_DEPTH_TEST);
	 glDepthMask(GL_TRUE);
	 glFrustumf(-size, size, -size / (rect.size.width / rect.size.height), size / 
	 (rect.size.width / rect.size.height), zNear, zFar); 
	 
	 glViewport(0, 0, rect.size.width, rect.size.height); 
	 glMatrixMode(GL_MODELVIEW);
	 glLoadIdentity(); 
	 glClearColor(0.0f, 0.0f, 0.0f, 1.0f); 
	 colors = [[NSMutableArray alloc] initWithCapacity:20];
	 for (int i =0; i < 20; i++)
	 [colors addObject:[UIColor randomColor]];
	 }
	 
	 - (void)drawView:(GLView*)view;
	 {
	 
	 
	 static GLfloat      rico;   
	 static const GLfloat icosahedronVertices[]= {
	 0, -0.525731, 0.850651,
	 0.850651, 0, 0.525731,
	 0.850651, 0, -0.525731,
	 -0.850651, 0, -0.525731,
	 -0.850651, 0, 0.525731,
	 -0.525731, 0.850651, 0,
	 0.525731, 0.850651, 0,
	 0.525731, -0.850651, 0,
	 -0.525731, -0.850651, 0,
	 0, -0.525731, -0.850651,
	 0, 0.525731, -0.850651,
	 0, 0.525731, 0.850651,
	 };
	 static const GLubyte icosahedronFaces[] = {
	 1, 2, 6,
	 1, 7, 2,
	 3, 4, 5,
	 4, 3, 8,
	 6, 5, 11,
	 5, 6, 10,
	 9, 10, 2,
	 10, 9, 3,
	 7, 8, 9,
	 8, 7, 0,
	 11, 0, 1,
	 0, 11, 4,
	 6, 2, 10,
	 1, 6, 11,
	 3, 5, 10,
	 5, 4, 11,
	 2, 7, 9,
	 7, 1, 0,
	 3, 9, 8,
	 4, 8, 0,
	 };
	 static const GLubyte icosahedronNumberOfFaces = 60;
	 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	 
	 // Icosahedron
	 glLoadIdentity(); 
	 glEnableClientState(GL_VERTEX_ARRAY);
	 glTranslatef(0.0f,0.0f,-2.0f);
	 glRotatef(rico,1.0f,1.0f,1.0f);
	 
	 glVertexPointer(3, GL_FLOAT, 0, icosahedronVertices);
	 for(int i = 0; i < icosahedronNumberOfFaces; i += 3) 
	 { 
	 UIColor *oneColor = [colors objectAtIndex:i/3];
	 [oneColor setOpenGLColor];
	 
	 glDrawElements(GL_TRIANGLES, 3, GL_UNSIGNED_BYTE, &icosahedronFaces[i]);
	 } 
	 
	 glDisableClientState(GL_VERTEX_ARRAY);
	 
	 static NSTimeInterval lastDrawTime;
	 if (lastDrawTime)
	 {
	 NSTimeInterval timeSinceLastDraw = [NSDate timeIntervalSinceReferenceDate] - lastDrawTime;
	 rico+=50 * timeSinceLastDraw;               
	 }
	 
	 // ------------------------------------------------
	 // Draw HUD ---------------------------------------
	 // ------------------------------------------------
	 [self switchToOrtho];
	 
	 static const GLfloat squareVertices[] = {
	 5.0f, 150.0f,
	 5.0f, 250.0f,
	 100.0f, 250.0f,
	 100.0f, 150.0f
	 };
	 
	 glLineWidth(3.0);
	 glColor4f(0.0, 0.0, 1.0, 1.0); // blue
	 glTranslatef(5.0, 0.0, 0.0);
	 glVertexPointer(2, GL_FLOAT, 0, squareVertices);
	 glEnableClientState(GL_VERTEX_ARRAY);
	 
	 glDrawArrays(GL_LINE_LOOP, 0, 4);
	 glTranslatef(100.0, 0.0, 0.0);
	 glColor4f(1.0, 0.0, 0.0, 1.0);  // Red
	 glDrawArrays(GL_LINE_LOOP, 0, 4);
	 glTranslatef(100.0, 0.0, 0.0);
	 glColor4f(1.0, 1.0, 0.0, 1.0);  // Yellow
	 glDrawArrays(GL_LINE_LOOP, 0, 4);
	 
	 
	 glEnable(GL_TEXTURE_2D);
	 glEnable(GL_BLEND);
	 glBlendFunc (GL_ONE, GL_ONE);
	 glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	 glColor4f(1.0, 1.0, 1.0, 1.0);
	 glLoadIdentity();
	 Texture2D *textTex = [[Texture2D alloc] initWithString:@"Text" 
	 dimensions:CGSizeMake(100., 40.0) 
	 alignment:UITextAlignmentCenter 
	 font:[UIFont boldSystemFontOfSize:36.0]];
	 [textTex drawAtPoint:CGPointMake(160.0, 440.0) depth:-1];
	 glDisable(GL_BLEND);
	 glDisable(GL_TEXTURE_2D);
	 glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	 
	 [self switchBackToFrustum];
	 
	 lastDrawTime = [NSDate timeIntervalSinceReferenceDate];
	 }	 
	 */

	//======================================================================================================
	void enableBackfaceCulling( void ) {
		TombstoneBackfaceCulling = TRUE;
	}
	
	//======================================================================================================
	void disableBackfaceCulling( void ) {
		TombstoneBackfaceCulling = FALSE;
	}

	//======================================================================================================
	void offsetScreen( float offX, float offY, float offZ = 0.0 ) {
		TombstoneOffsetX = offX;
		TombstoneOffsetY = offY;
		TombstoneOffsetZ = offZ;
	}

	
	//======================================================================================================
	void shakeScreen( float magnitude ) {
		TombstoneRandomClass temp;
		TombstoneOffsetX = ( 0.0 -temp.randFloat( 0.0, magnitude ) ) +temp.randFloat( 0.0, magnitude );
		TombstoneOffsetY = ( 0.0 -temp.randFloat( 0.0, magnitude ) ) +temp.randFloat( 0.0, magnitude );
	}

	//======================================================================================================
	void resetScreenShake( void ) {
		TombstoneOffsetX = 0.0;
		TombstoneOffsetY = 0.0;
	}

	//======================================================================================================
	void setColour( GLfloat red, GLfloat green, GLfloat blue ) {
		GLRed = red;
		GLGreen = green;
		GLBlue = blue;
	}
	
	//======================================================================================================
	void setAlpha( GLfloat alpha ) {
		GLAlpha = alpha;
	}
	
	//======================================================================================================
	void switchTo2D( void ) {
		//switch to Ortho view
		glDisable(GL_DEPTH_TEST);
		glMatrixMode(GL_PROJECTION);
		glPushMatrix();
		glLoadIdentity();
#if TARGET_OS_IPHONE || TARGET_OS_SIMULATOR
		glOrthof(0, TombstoneWidth, 0, TombstoneHeight, -5, 1);       
#else
		glOrtho( 0, TombstoneWidth, 0, TombstoneHeight, -5, 1 );
#endif
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
	}
	
	//======================================================================================================
	void switchTo3D( void ) {
		//switch to 3d view
		glEnable(GL_DEPTH_TEST);
		glMatrixMode(GL_PROJECTION);
		glPopMatrix();
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
	}
	
	//class functions
	//THESE NEED TO BE HERE BECAUSE OF LIST ENTRY ABOVE, THIS IS TO STOP A SILLY C++ ERROR OCCURING
	//======================================================================================================
	void EnableEngineStates( void ) {
		glEnableClientState( GL_VERTEX_ARRAY );				//enable GL vertex arrays
		glEnableClientState( GL_TEXTURE_COORD_ARRAY );		//enable GL texturing system
	}

	//======================================================================================================
	void DisableEngineStates( void ) {
		glDisableClientState( GL_TEXTURE_COORD_ARRAY );
		glDisableClientState( GL_VERTEX_ARRAY );
	}

	//======================================================================================================
	void shutdownEngine( void ) {
		//shut down the engine
		TTextureRegistry.ShutdownRegistry();
		#if defined( __WINDOWS__ )
			DisableOpenGL (hWnd, hDC, hRC);
			DestroyWindow (hWnd);
		#endif
	}

	//======================================================================================================
	void startupWindowTitle( string windowTitle ) {
		//this is used to set the title of the window system
		TombstoneWindowTitle = windowTitle;
	}

	//======================================================================================================
	void startupWindowSize( long width, long height, long depth = 16 ) {
		TombstoneWidth = width;
		TombstoneHeight = height;
		TombstoneDepth = depth;
	}

	//======================================================================================================
	void startFullScreen( void ) {
		TombstoneFullScreen = TRUE;
	}

	//======================================================================================================
	void startWindowed( void ) {
		TombstoneFullScreen = FALSE;
	}

	//======================================================================================================
	void startupAlignment( long Alignment = TOMBSTONEALIGNMENT_VERTICAL ) {
		//sets the alignment of the screen for horizontal style games (IPHONE ONLY)
		TombstoneAlignment = Alignment;
	}

	//======================================================================================================
#if !TARGET_OS_IPHONE && !TARGET_OS_SIMULATOR
	int InitGLUT( void (*dI)(void), void (*iI)(void), void (*kI)( unsigned char, int, int ), void (*rI)( int, int ) ) {
		//Now we can call GLUT from within Tombstone using this system
		glutDisplayFunc( (*dI) );
		glutIdleFunc( (*iI) );
		glutKeyboardFunc ( (*kI) );
		glutReshapeFunc( (*rI) );
		
		return( 0 );
	}	
#endif
	//======================================================================================================
	void startupEngine( short ThreeD = FALSE, int SEargc = 0, char* SEargv[] = NULL ) {
		//Set up OpenGL projection matrix
		//check endianess
		endianess();
		
		#if TARGET_OS_IPHONE || TARGET_OS_SIMULATOR
			if ( TombstoneAlignment == TOMBSTONEALIGNMENT_VERTICAL ) {
				TombstoneWidth = 320;
				TombstoneHeight = 480;
			} else {
				TombstoneWidth = 480;
				TombstoneHeight = 320;
			}
		#endif
		#if !TARGET_OS_IPHONE && !TARGET_OS_SIMULATOR
			//we dont want this run if we are using iPhone stuff
			cout << "Startup OpenGL Engine..." << endl;
			InitGL( SEargc, SEargv );								//in TINIT
			cout << "GLUT Initialise complete..." << endl;
		#endif
		glMatrixMode(GL_PROJECTION);				//Projection, Modelview,
		if ( ThreeD == FALSE ) {
			//2d camera (Orthagonal mode)
			#if TARGET_OS_IPHONE || TARGET_OS_SIMULATOR
				glOrthof( -160, 160, -240, 240, -500, 500 );
			#else
				glOrtho(-160, 160, -240, 240, -500, 500);		//left, right, bottom, top, near, far
			#endif
		} else {
			//3d camera (Frustum culling mode)
			firstCamera.SetupCamera();
			#if TARGET_OS_IPHONE || TARGET_OS_SIMULATOR
				glFrustumf( -160, 160, -240, 240, -500, 500 );
			#else
				glFrustum( -160, 160, -240, 240, -500, 500 );
			#endif
			firstCamera.SetCameraViewport( 0.0, 0.0, (GLsizei)TombstoneWidth, (GLsizei)TombstoneHeight );
			firstCamera.SetCameraRange( 0.01, 1000.0 );
			firstCamera.SetCameraZoom( 0.01, 500.0 );
			firstCamera.SetCameraFOV( 50.0, 0.75 );
			firstCamera.PositionCamera( 0.0, 0.0, 450.0 );
			firstCamera.RotateCamera( 0.0, 0.0, 0.0 );
			firstCamera.Render();
		}
		glMatrixMode(GL_MODELVIEW);
		//set the viewport to desired mode
		glViewport( 0, 0, TombstoneWidth, TombstoneHeight );
		//Initialize OpenGL states
		glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
		glEnable(GL_TEXTURE_2D);
		glEnable(GL_BLEND);
		glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
		glEnable(GL_DEPTH_TEST);
		glDepthMask(GL_TRUE);
				
		//reset system counters
		gNumSprites = 0;
		gNumTextures = 0;
		gNumEntities = 0;
		
		setAlpha( 1.0 );
		setColour( 255, 255, 255 );
		SetClsColour( 0.0, 0.0, 0.0 );
		SetMaskColour( 255, 255, 255 );
		MaskAlpha = 1.0;
		ClsAlpha = 1.0;
		MaskActive = FALSE;
		GLAlpha = 1.0;
		
		cout << "Startup complete." << endl;
	}

	//======================================================================================================
	void updateWorld( void ) {
		//update ALL entities etc
		list< TEntityClass*>::iterator i;

		glMatrixMode( GL_MODELVIEW );
		glEnableClientState( GL_COLOR_ARRAY );
		glEnableClientState(GL_TEXTURE_COORD_ARRAY);
		
		for ( i =TEntityRegistry.begin(); i !=TEntityRegistry.end(); i++ ){
			TEntityClass* temp = *i;
			//position the mesh			
			if ( temp->hidden == FALSE ) {
//				cout << "updateWorld:Rendering..." << temp->ID << ": X:" << temp->X << endl;

				glPushMatrix();				
				if ( temp->backfaceCulling == TRUE ) {		//backface culling system
					glDisable( GL_CULL_FACE );
				} else {
					glEnable( GL_CULL_FACE );
				}
				glLoadIdentity();
				//				printf( "Repositioning to:X:%f Y:%f Z:%f\n", temp->X, temp->Y, temp->Z );
				glTranslatef( temp->X, temp->Y, temp->Z );
				//setup rotations of image (this works with Paste Sprite and its pitch/yaw/roll etc
				for ( int surf = 0; surf < temp->surfaceCount; surf++ ) {
					if ( temp->Surface[ surf ]->fxVertexColour == TRUE ) {
						//lighting needs to be turned off
						glDisable( GL_LIGHTING );
					}
					glRotatef( temp->Xr, 1, 0, 0 );
					glRotatef( temp->Yr, 0, 1, 0 );
					glRotatef( temp->Zr, 0, 0, 1 );
					glColor4f( temp->Red, temp->Green, temp->Blue, temp->Alpha );	//colour to required rgba value
						
					//specularity or Shininess ;)
					specularity[ 0 ] = temp->Surface[ surf ]->ShineValue;
					specularity[ 1 ] = temp->Surface[ surf ]->ShineValue;
					specularity[ 2 ] = temp->Surface[ surf ]->ShineValue;
					specularity[ 3 ] = 1.0;
					glMaterialfv(GL_FRONT, GL_SPECULAR, specularity );
						
					if ( temp->name.Tname != 0x0 ) {
						glBindTexture( GL_TEXTURE_2D, temp->name.Tname );						//bind its texture
						//						glMaterialfv( GL_FRONT, GL_AMBIENT, &temp->Surface[ surf ]->vertexColors[ 0 ] );
					}
					glColorPointer(4, GL_FLOAT, 0, &temp->Surface[ surf ]->vertexColours[ 0 ] );
					glNormalPointer(GL_FLOAT, 0, &temp->Surface[ surf ]->normals[ 0 ] );
					glTexCoordPointer( 2, GL_FLOAT,0, &temp->Surface[ surf ]->tverts[ 0 ] );				//create triangles (0,1,2)
					glVertexPointer( 3, GL_FLOAT, 0, &temp->Surface[ surf ]->verts[ 0 ] );					//setup vertices (3 points PER vertices)
					glDrawElements(GL_TRIANGLES, temp->Surface[ surf ]->vertexPoints ,GL_UNSIGNED_BYTE, &temp->Surface[ surf ]->triangleIndex[ 0 ] );//temp->vertexPoints *3
					
					if ( temp->Surface[ surf ]->fxVertexColour == TRUE ) {
						glEnable( GL_LIGHTING );
					}
				}
				glPopMatrix();
			}
		}	
		
		//re-enable backface culling
		if ( TombstoneBackfaceCulling == FALSE ) {
			glEnable( GL_CULL_FACE );
		} else {
			glDisable( GL_CULL_FACE );
		}
		
		glDisableClientState(GL_TEXTURE_COORD_ARRAY);
		glDisableClientState( GL_COLOR_ARRAY );
	}
	
	//======================================================================================================
	void SetMaskColour( unsigned short red, unsigned short green, unsigned short blue ) {
		//this will setup the mask color so its removed in images that are loaded
//		printf( "Mask color set to : R:%i G:%i B:%i\n", red, green, blue );
		MaskRed = red;
		MaskGreen = green;
		MaskBlue = blue;
		MaskActive = TRUE;
	}
	
	//======================================================================================================
	unsigned short RGBA_GetRed( long rgba ) {
		return( ( rgba >> 16 ) &0xFF );
	}
	
	//======================================================================================================
	unsigned short RGBA_GetGreen( long rgba ) {
		return( ( rgba >> 8 ) &0xFF );
	}
	
	//======================================================================================================
	unsigned short RGBA_GetBlue( long rgba ) {
		return( rgba &0xFF );
	}
	
	//======================================================================================================
	unsigned short RGBA_GetAlpha( long rgba ) {
		return( ( rgba >> 24 ) &0xFF );
	}
	
	//======================================================================================================
	void TurnMaskColorOff( void ) {
		MaskActive = FALSE;
	}
	
	//======================================================================================================
	void SetClsColour( GLfloat red, GLfloat green, GLfloat blue ) {
		ClsRed = red;
		ClsGreen = green;
		ClsBlue = blue;
	}
	
	//======================================================================================================
	void Cls( void ) {
		glClearColor( ClsRed, ClsGreen, ClsBlue, ClsAlpha );
		glClear( GL_COLOR_BUFFER_BIT );
	}	

	//======================================================================================================
	void SetLineWidth( GLfloat lW ) {
		LineWidth = lW;
		glLineWidth( LineWidth );
	}

	//======================================================================================================
	void Plot( GLfloat x, GLfloat y ) {
	// this code will draw a point located at [100, 100, -25]
		GLfloat squareVertices[] = {
			x, y, 0
		};
		glColor4f( GLRed, GLGreen, GLBlue, GLAlpha );					//colour to required rgba value
		glDisable( GL_TEXTURE_2D );
		glVertexPointer( 3, GL_FLOAT, 0, squareVertices );
		glDrawArrays( GL_POINTS, 0, 1 );
		glEnable( GL_TEXTURE_2D );
	}
	
	//======================================================================================================
	void Rectangle( GLfloat topLeftX, GLfloat topLeftY, GLfloat bottomRightX, GLfloat bottomRightY ) {
		GLfloat squareVertices[] = {
			topLeftX, topLeftY,						//Top left
			topLeftX, bottomRightY,					//bottom left
			bottomRightX, bottomRightY,				//bottom right
			bottomRightX, topLeftY					//top right
		};
		glColor4f( GLRed, GLGreen, GLBlue, GLAlpha );					//colour to required rgba value
		glDisable( GL_TEXTURE_2D );
		glEnable( GL_VERTEX_ARRAY );
		glTexCoordPointer( GL_FLOAT, 0, 0, NULL );
		glVertexPointer(2, GL_FLOAT, 0, squareVertices);
		glDrawArrays( GL_LINE_LOOP, 0, 4 );
		glEnable( GL_TEXTURE_2D );
//		glDrawElements(GL_LINE_LOOP, 4 ,GL_UNSIGNED_BYTE, &triangles );//temp->vertexPoints *3
	}
	
	//======================================================================================================
	void Line( GLfloat x, GLfloat y, GLfloat x2, GLfloat y2 ) {
		GLfloat lineVertices[] = {
			x, y, 0,
			x2, y2, 0
		};
		glColor4f( GLRed, GLGreen, GLBlue, GLAlpha );					//colour to required rgba value
		glDisable( GL_TEXTURE_2D );
		glVertexPointer( 3, GL_FLOAT, 0, lineVertices );
		glDrawArrays( GL_LINES, 0, 2 );
		glEnable( GL_TEXTURE_2D );
	}
	
	
	
	/* ============================================================================================================================ */
	void VerticalWave( TTexture imageTexture, long xW, long yW, float startAngle = 0.0, float increment = 5.0, float radius = 5.0, long segmentSize = 1, long fadeMode = FADE_NOFADE ) {
		/*
		 this is a simple sine wave effect that will be applied to the image
		 the whole effect will be applied with one sprite that will have its
		 UV coordinates adjusted till the effect is completed.
		 
		 increment is the increment to be added to the Angle of the sine wave the
		 greater the value the more severe the wave.
		 
		 segmentSize is the size of each slice of the wave
		 
		 THIS WILL BE THE VERTICAL EFFECT (top to bottom)
		 */
		TSprite TWaterSprite;
		float	VWAngle;
		int		VWPos;
		float	fadeAlpha = 1.0;
		float	fadeAddition = 0.0;
		
		if ( imageTexture.Tname == 0x0 ) {
			cout << "Effect problem: no texture specified" << endl;
			return;
		}
		
		xW -= imageTexture.Twidth /2;
		
		TWaterSprite.CreateSprite( imageTexture );
		
		switch ( fadeMode ) {
			case FADE_FROMTOP:
				fadeAlpha = 0.0;
				fadeAddition = ( 1.0 /imageTexture.Twidth ) *2;
				break;
			case FADE_TOMIDDLE:
				fadeAlpha = 0.0;
				fadeAddition = ( 1.0 /imageTexture.Twidth ) *4;
				break;
			case FADE_FROMBOTTOM:
				fadeAlpha = 1.0;
				fadeAddition = 0 -( ( 1.0 /imageTexture.Twidth ) *2 );
				break;
			case FADE_FROMMIDDLE:
				fadeAlpha = 1.0;
				fadeAddition = 0 -( ( 1.0 /imageTexture.Twidth ) *4 );
				break;
		}
		
		VWAngle = startAngle;
		VWPos = xW;
		for ( long pos = 0; pos <imageTexture.Twidth; pos += ( segmentSize +1 ) ) {
			if ( fadeMode == FADE_RANDOM ) fadeAlpha = TombstoneRandom.randFloat( 0.0, 1.0 );
			setAlpha( fadeAlpha );
			fadeAlpha += fadeAddition;
			switch ( fadeMode ) {
				case FADE_TOMIDDLE:
					if ( fadeAlpha >= 1.0 ) {
						fadeAddition = 0 -fadeAddition;
					}
					break;
				case FADE_FROMMIDDLE:
					if ( fadeAlpha <= 0.0 ) {
						fadeAddition = 0 -fadeAddition;
					}
					break;
			}
			TWaterSprite.SetSpriteUV( imageTexture,  pos, 0, segmentSize +1, imageTexture.Twidth );
			TWaterSprite.PasteSprite( VWPos, yW+( sin( VWAngle *PI/180 ) *radius ) );
			VWAngle += increment;
			VWPos += ( segmentSize +1 );
		}
		setAlpha( 1.0 );
	}
	
	/* ============================================================================================================================ */
	void HorizontalWave( TTexture imageTexture, long xW, long yW, float startAngle = 0.0, float increment = 5.0, float radius = 5.0, long segmentSize = 1, short fadeMode = FADE_NOFADE ) {
		/*
		 this is a simple sine wave effect that will be applied to the image
		 the whole effect will be applied with one sprite that will have its
		 UV coordinates adjusted till the effect is completed.
		 
		 increment is the increment to be added to the Angle of the sine wave the
		 greater the value the more severe the wave.
		 
		 segmentSize is the size of each slice of the wave
		 
		 THIS IS THE HORIZONTAL EFFECT (side to side)
		 */
		TSprite TWaterSprite;
		float	HWAngle;
		int		HWPos;
		float	fadeAlpha = 1.0;
		float	fadeAddition = 0.0;
		
		if ( imageTexture.Tname == 0x0 ) {
			cout << "Effect problem: no texture specified" << endl;
			return;
		}
		
		yW -= imageTexture.Theight /2;
		
		TWaterSprite.CreateSprite( imageTexture );
		
		switch ( fadeMode ) {
			case FADE_FROMTOP:
				fadeAlpha = 0.0;
				fadeAddition = ( 1.0 /imageTexture.Theight ) *2;
				break;
			case FADE_TOMIDDLE:
				fadeAlpha = 0.0;
				fadeAddition = ( 1.0 /imageTexture.Theight ) *4;
				break;
			case FADE_FROMBOTTOM:
				fadeAlpha = 1.0;
				fadeAddition = 0 -( ( 1.0 /imageTexture.Theight ) *2 );
				break;
			case FADE_FROMMIDDLE:
				fadeAlpha = 1.0;
				fadeAddition = 0 -( ( 1.0 /imageTexture.Theight ) *4 );
				break;
		}
		
		HWAngle = startAngle;
		HWPos = yW+imageTexture.Theight;//yW;
		for ( long pos = 0;pos <imageTexture.Theight; pos += ( segmentSize +0 ) ) {
			if ( fadeMode == FADE_RANDOM ) fadeAlpha = TombstoneRandom.randFloat( 0.0, 1.0 );
			setAlpha( fadeAlpha );
			fadeAlpha += fadeAddition;
			switch ( fadeMode ) {
				case FADE_TOMIDDLE:
					if ( fadeAlpha >= 1.0 ) {
						fadeAddition = 0 -fadeAddition;
					}
					break;
				case FADE_FROMMIDDLE:
					if ( fadeAlpha <= 0.0 ) {
						fadeAddition = 0 -fadeAddition;
					}
					break;
			}
			TWaterSprite.SetSpriteUV( imageTexture, 0, pos, imageTexture.Twidth, segmentSize +1 );
			TWaterSprite.PasteSprite( xW+( sin( HWAngle *PI/180 ) *radius ), HWPos );
			HWAngle += increment;
			HWPos -= ( segmentSize +0 );
		}
		setAlpha( 1.0 );
	}	
};

extern TombstoneClass Tombstone;
