/*
 *  TombstoneRandomSystem.h
 *  FreeFalling
 *
 *  Created by EdzUp on 11/03/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */

#include <cstdlib>
#include <cmath>

class TombstoneRandomClass {
public:
	// rnd(n) returns random number range 0 - (n-1)
	void seedrnd( unsigned int value ) {
		srand( value );
	}
	
	void randomize( void ) {
		srand( time( NULL ) );
	}

	int randInt(const int &mins, const int &maxs)
	{
		int range = maxs - mins;
		int number = ( ((double)rand()/(double)RAND_MAX) *range);
		
		return (number +mins);
	}

	long randLong(const long &mins, const long &maxs)
	{
		long range = maxs - mins;
		long number = ( ((double)rand()/(double)RAND_MAX) *range);
		
		return (number +mins);
	}
	
	float randFloat(const float& mins, const float& maxs)
	{
		float range = maxs - mins;
		float num = ( ((double)rand()/(double)RAND_MAX) *range);
		return (num + mins);
	}
	
	// min(a,b) returns minimum of 2 values
	int min(int a,int b)
	{
		if(a < b)
			return a;
		return b;
	}
	
	// max(a,b) returns the maximum of 2 values
	
	int max(int a,int b)
	{
		if(a > b)
			return a;
		return b;
	}
	
	// sgn(n) returns the sign (-1, 0 or 1) of a value
	int sgn(int a)
	{
		if(a < 0)
			return -1;
		if(a > 0)
			return 1;
		return 0;
	}	
};

TombstoneRandomClass TombstoneRandom;
