/*
 *  TombstoneStringFunctions.h
 *  Tombstone Demo
 *
 *  Created by EdzUp on 25/06/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */
#include <iostream>
#include <string>
#include <list>
using namespace std;

//======================================================================================================
// STRING FUNCTIONS
//======================================================================================================
int InStr( const std::string& str, const std::string& what, int pos)
{
	// int InStr(start-1, str, what)
	if (pos >= 0)
	{
		if (pos == 0)
		{
			return str.find_first_of(what); 
		}else{
			return str.find_first_of(what, pos);
		};
	}else{
		return -1;
	};
	
	return -1;
}

//======================================================================================================
string Mid( const std::string& from, int location, int length ) {
	//	Mid$(a, b, c) <==> a.substr(b-1,c) // in C++ strings start at 0, in vb at 1
	return( from.substr( location, length ) );
}

//======================================================================================================
string Left( const std::string& from, int location ) {
	//	Left$(a, b) <==> a.substr(0,b)
	return ( from.substr( 0, location ) );
}

//======================================================================================================
string Right( const std::string& from, int location ) {
	//Right$(a, b) <==> a.substr(a.size() - b)
	return( from.substr( from.size() - location ) );
}

//======================================================================================================
bool hasEnding ( const std::string& fullString, const std::string& ending )
{
	if (fullString.length() >= ending.length()) {
		return (0 == fullString.compare (fullString.length() - ending.length(), ending.length(), ending));
	} else {
		return false;
	}
}

//======================================================================================================
string stripDirectory( char* filename ) {
	//this will remove a directory name from the filename / or \ are directories
	//dependent on platform
	return( "" );
}

//======================================================================================================
string getExtension( const std::string& filename ) {
	//this will return the extension of a file
	//from right till the . so picture.png will return png
	string	extension = "";
	long	dotLocation;
	
	//get location of . in filename to load
	dotLocation = InStr( filename, ".", filename.size()-5 );
	if ( dotLocation != -1 ) {
		//get the extension
		extension = Right( filename, filename.size() -dotLocation );
		return( extension );
	}
	
	return( "" );
}
