/*
 *  TombstoneFunctions.h
 *  Tombstone Demo
 *
 *  Created by EdzUp on 29/08/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */

//==================================================================================================================
void updateDemo( void ) {
	switch ( currentRender ) {
		case 0 : //startup
			title = "Welcome to the";
			information = "Tombstone Engine Demo";
			Yaw += 2;			
			break;
		case 1 : //basic image
			title = "Simple image drawing";
			information = "here we can see the Logo"; 
			Pitch = 0.0;
			Yaw = 0.0;
			Roll = 0.0; break;
		case 2 : //rotation of an image";
			title = "Rotation of a image";
			information = "Rolling on the z axis";
			Roll += 2.0; break;
		case 3 : //Alpha
			title = "Changing entity alpha";
			information = "fades the image";
			Roll = 0.0;
			Alpha -= 0.01;
			if ( Alpha < 0.0 ) Alpha = 0.0;
			Quad.EntityAlpha( Alpha ); break;
		case 4 : //playing with colour
			title = "Changing the colour";
			information = "any colour you like";
			Quad.EntityAlpha( 1.0 );
			Quad.EntityColour( 255-timer, timer, Blue ); break;
		case 5 : //changing scale
			title = "Changing scale, big or";
			information = "small we got it all"; break;
		case 6 : //rotation
			title = "Full rotation";
			information = "complete 3d rotation";
			Pitch += 2.0;
			Yaw += 1.0;
			Roll += 0.5; break;
		case 7 ://Vertex Color
			Pitch = 0.0;
			Yaw = 0.0;
			Roll = 0.0;
			title = "Vertex colour, playing";
			information = "with vertex colour";break;
		case 8 ://Vertex Alpha
			title = "Vertex Alpha, playing";
			information = "with vertex alpha";break;
		case 9 ://Texture change
			title = "Texture changing";
			information = "yes its this easy"; break;
		case 10://and back
			title = "And back again";
			information = "texture on the fly"; break;
		case 11://capturing
			title = "Screen capture";
			information = "capturing to texture";
			Pitch += 2.0;
			Yaw += 1.0;
			Roll += 0.5;
			Sprite.PasteSprite( 0, 0, 0, Pitch, Yaw, Roll );
			break;
		case 12://Rectagles
			Pitch = 0.0;
			Yaw = 0.0;
			Roll = 0.0;
			title = "Rectangles and lines";
			information = "simple drawing";
			Tombstone.Plot( (rand() %320)-160, (rand() %480)-240 );
			Tombstone.Line( (rand() %320)-160, (rand() %480)-240, (rand() %320)-160, (rand() %480)-240 );
			Tombstone.Rectangle( (rand() %10)-160, (rand() %10)-200, ( rand() %10 )+140, ( rand() %10 )+200 );
			break;
		case 13://Horizontal fluff
			title = "Horizontal slices";
			information = "waves is also ok";
			Tombstone.HorizontalWave( TombstoneLogo, 0, 0, 0, 0, 0, 1, FADE_RANDOM );
			Quad.hideEntity();
			break;
		case 14://Vertical stuff
			title = "Vertical slices";
			information = "waves is also ok";
			Tombstone.VerticalWave( TombstoneLogo, 0, 0, 0, 0, 0, 1, FADE_RANDOM );
			break;
		case 15://randomize
			capture.randomizeTexture( FULLSCREEN_RANDOMBLUE, 255 );//grabTexture( 0, 0, 320, 480 );		//32, 112
			//				Quad.EntityTexture( capture );
			Sprite.CreateSprite( capture );
			Quad.hideEntity();
			Sprite.PasteSprite( 0, 0 );
			break;
		default: //unknown
			Quad.showEntity();
			Quad.EntityTexture( TombstoneLogo );
			title = "...";
			information = "..."; break;
	}
	/*
	switch ( demoInAction ) {
		default://basic
			Title = "...";
			InfoText = "...";
			break;
	}*/
}

//==================================================================================================================
void startup( void ) {
	cout << "STARTUP" << endl;
	Tombstone.startupEngine( TRUE );
	Tombstone.startupLighting();
	Tombstone.setAmbientLight( 0, 1, 1, 1 );
	Tombstone.SetClsColour( 0, 0, 0 );
	TombstoneRandom.randomize();
	TombstoneSound.StartOpenALSoundSystem();
	
	footer.assign( "Tombstone Engine v" );
	footer.append( TOMBSTONE_VERSION );
	
	music.loadSound( "Captive - Amiga.mp3", TRUE );
	music.playSound( 1.0 );
	
	//load in the font (FallinFont.png) into the game engine
	TextTexture.loadTexture( "FallinFont.png" );
	TombstoneText.SetupTextSystem( 7, 14, 92, "!~#$%&`()'+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz" );
	TombstoneText.textImage[ 0 ].GrabSpriteSet( TextTexture, 0, 0, 16, 6, 16, 16, 92, TombstoneText.textImage );
	
	//Load in smallfont.png
	SmallFontTexture.loadTexture( "smallfont.png" );
	SmallText.SetupTextSystem( 6, 8, 256, "```````````````````````````````` !'#$%&`()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~" );
	SmallText.textImage[ 0 ].GrabSpriteSet( SmallFontTexture, 0, 0, 16, 16, 16, 16, 256, SmallText.textImage );
	
	//load in data
	BackgroundTexture.loadTexture( "Egypt_bd.png" );
	Background.SetSpriteUV( BackgroundTexture, 0, 0, 320, 480, TRUE );
	TombstoneLogo.loadTexture( "TombstoneLogo.png" );
	GDLogo.loadTexture( "GDLogo.png" );
	capture.createTexture( 320, 480 );
	
	Guide.LoadSprite( "guide.png" );
	Guide.spriteFlipVertical();
	
	Quad.CreateQuad();
	Quad.PositionEntity( 0, 0, -4 );
	Quad.EntityTexture( TombstoneLogo );
	Quad.EntityFX( 16 );
	
//	Sheet.CreateSheet( 10, 10 );
//	Sheet.PositionEntity( 0, 0, -4 );
//	Sheet.EntityTexture( GDLogo );
//	Sheet.EntityFX( 16 );
	
	//setup the renders
	currentRender = 0;
	maximumRender = 16;
	title = "0:Here we go...";
	information = "Tombstone DEMO 0.1b";
	
	timer = 250;
	Red = 255;
	Green = 255;
	Blue = 255;
	Alpha = 1.0;
}