//
//  Tombstone_DemoAppDelegate.m
//  Tombstone Demo
//
//  Created by EdzUp on 15/05/2010.
//  Copyright Graveyard Dogs 2010. All rights reserved.
//

#import "Tombstone_DemoAppDelegate.h"
#import "Tombstone.h"
#import "EAGLView.h"					//EdzUp's heavily modified EAGLView
#import "EdzUpStringSystem.h"			//EdzUps own string system

//includes for this game only
#include <iostream>
#include "TombstoneDemoVariables.h"
#include "TombstoneDemoFunctions.h"

@implementation Tombstone_DemoAppDelegate

@synthesize window;
@synthesize glView;
@synthesize renderTimer;

-(void)MAINLOOP {
	
	//main loop for the demonstration
	[glView startDrawing];
	Tombstone.EnableEngineStates();
	Tombstone.Cls();
	Background.PasteSprite( 0, 0 );
	SmallText.DrawText( title, -70, 180, FALSE, TRUE );
	SmallText.DrawText( information, -70, 160, FALSE, TRUE );
	
	TombstoneText.DrawText( footer, 0, -200, TRUE, TRUE );
	
	Quad.RotateEntity( Pitch, Yaw, Roll );
	Guide.HorizontalWave( -110, 160, 0, 0, 0, 1, FADE_RANDOM );
	updateDemo();
	Tombstone.updateWorld();
	Tombstone.DisableEngineStates();
	[glView endDrawing];
	
	timer--;
	if ( timer <0 ) {
		//update the system
		currentRender ++;
		timer = 250;
		
		if ( currentRender >maximumRender ) currentRender = 0;
		Pitch = 0.0;
		Yaw = 0.0;
		Roll = 0.0;
		Alpha = 1.0;
		Red = 255;
		Green = 255;
		Blue = 255;
		Quad.EntityAlpha( 1.0 );
		Quad.EntityColour( 255, 255, 255 );
		
		switch( currentRender ) {
			case 5 ://rescale
				Quad.EntityScale( 2.0, 1.0, 0.5 ); break;
			case 6 :	//need rescaling back
				Quad.EntityScale( 0.5, 1.0, 2.0 ); break;
			case 7 :	//set it to vertex colours
				Quad.Surface[ 0 ]->SurfaceFX( SURFACEFX_VERTEXCOLOUR );
				Quad.Surface[ 0 ]->VertexColour( 0, 255, 0, 0 ); break;
			case 8 :	//set it to vertex colours
				Quad.Surface[ 0 ]->SurfaceFX( SURFACEFX_VERTEXCOLOUR );
				Quad.Surface[ 0 ]->VertexAlpha( 4, 0.1 ); break;
			case 9 :	//change texture
				Quad.EntityTexture( GDLogo ); break;
			case 10 :	// and back
				Quad.EntityTexture( TombstoneLogo ); break;
			case 11 :	//capturing
				capture.grabTexture( 0, 0, 320, 480 );		//32, 112
//				Quad.EntityTexture( capture );
				Sprite.CreateSprite( capture );
				Quad.hideEntity();
				break;
			case 12 :	//back
				Sprite.FreeSprite();
				Quad.EntityTexture( TombstoneLogo );
				Quad.showEntity(); break;
			default:	//usual
				Quad.EntityTexture( TombstoneLogo );
				Quad.Surface[ 0 ]->SurfaceFX( SURFACEFX_NONE );
				Quad.Surface[ 0 ]->VertexColour( 0, 255, 255, 255 );
				Quad.Surface[ 0 ]->VertexAlpha( 4, 1.0 ); break;
		}
		
	}
}

//-----------------------------------------------------------------------------------------------------------------------------
- (void) applicationDidFinishLaunching:(UIApplication *)application
{
	startup();
	renderTimer = [NSTimer scheduledTimerWithTimeInterval:(1.0/FPS) target:self selector:@selector(MAINLOOP) userInfo:nil repeats:YES];
}
	
- (void)applicationWillResignActive:(UIApplication *)application
{
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
}

- (void)applicationWillTerminate:(UIApplication *)application
{
}

- (void)dealloc
{
    [window release];
    [glView release];

    [super dealloc];
}

@end
