#include <iostream>
#include "Tombstone.h"

// Function Prototypes -------------------------------------------------------

//void InitGL(void);
void DrawGLScene(void);
void ReSizeGLScene(int Width, int Height);
void keyPressed(unsigned char key, int x, int y);

GLfloat		angle = 0;
TEntity		Square;
TEntity		Triangle;
TEntity		Cube;
TEntity		LWO;
TTexture	Texture;
TSprite		Sprite;
GLfloat		VertArray[ 12 ];
GLfloat		Index[ 6 ];

long ID;

int main(int argc, char** argv) {
    // insert code here...
	Tombstone.startupWindowTitle( "Tombstone OSX version test (0.1nl)" );
	Tombstone.startupWindowSize( 640, 480, 32 );
	Tombstone.startupEngine( TRUE, argc, argv );
	Tombstone.InitGLUT( DrawGLScene, DrawGLScene, keyPressed, ReSizeGLScene );
	LWO.LoadLWO( "Cenobite.lwo" );
	Square.CreateQuad();
	Texture.loadTextureRAW( "RAWTest", 4, 128, 128 );
	Square.EntityTexture( Texture, 0, 0 );
	Triangle.CreateEntity();
	ID = Triangle.CreateSurface();
	Triangle.hidden = FALSE;
	Triangle.Surface[ ID ]->AddVertex( 0.0, 1.0, 0.0, 0.5, 0.0 );
	Triangle.Surface[ ID ]->AddVertex( -1.0, -1.0, 0.0, 0.0, 1.0 );
	Triangle.Surface[ ID ]->AddVertex( 1.0, -1.0, 0.0, 1.0, 1.0 );
	Triangle.Surface[ ID ]->AddTriangle( 0, 1, 2 );
	Triangle.Surface[ ID ]->texturePoints = 3;
	Triangle.updateRegistry();
	Triangle.EntityTexture( Texture, 0, 0 );
	
	Square.backfaceCulling = TRUE;
	Square.EntityFX( 16 );
	
	cout << ( TOMBSTONEALIGNMENT_HORIZONTAL|TOMBSTONEALIGNMENT_VERTICAL ) << endl;
	
	test( -0.5 );
	
	Cube.CreateCube();
	Square.PositionEntity( 1.5, 0.0, -6.0 );
	Triangle.PositionEntity( -1.5, 0.0, -6.0 );
	Cube.PositionEntity( 0.0, 0.0, -8.0 );
	LWO.PositionEntity( 0.0, 0.0, -6.0 );
	glEnable( GL_CULL_FACE );
	glutMainLoop();
	Tombstone.shutdownEngine();
    return 0;
}


// Init ----------------------------------------------------------------------

// DrawGLScene ---------------------------------------------------------------

void DrawGLScene(void)
{    
	angle= angle + 0.1;
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Clear The Screen And The Depth Buffer
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();										// Reset The View
	glBindTexture( GL_TEXTURE_2D, Texture.Tname );
	Tombstone.EnableEngineStates();
	Square.RotateEntity( angle, 0.0, 0.0 );
	Triangle.RotateEntity( 0.0, angle, -angle );
	Cube.RotateEntity( angle, 0.0, -angle );
	LWO.RotateEntity( -angle, 0.0, angle );
	Tombstone.updateWorld();
    glFlush();

	glutSwapBuffers();
}

// ReSizeGLScene ------------------------------------------------------------

void ReSizeGLScene(int Width, int Height)
{
	glViewport (0, 0, (GLsizei) Width, (GLsizei) Height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	gluPerspective(45.0, (GLfloat) Width / (GLfloat) Height, 0.1, 100.0);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

/* The function called whenever a key is pressed. */
void keyPressed(unsigned char key, int x, int y) 
{
    /* avoid thrashing this procedure */
    usleep(100);
	
    /* If escape is pressed, kill everything. */
    if (key == ESCAPE) 
    { 
		/* shut down our window */
		glutDestroyWindow( OpenGLWindow ); 
		
		/* exit the program...normal termination. */
		exit(0);                   
    }
}