/*
 *  TRegistry.h
 *  Tombstone Demo
 *
 *  Created by EdzUp on 25/06/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */

#include <iostream>
#include <string>
#include <list>
#include <vector>
#import "TEntity.h"

using namespace std;
/*
 This will handle all storage of textures etc in the OpenGL system this will be called on Exit to release all resources
*/

class TRegistryTextureClass {
private:
	vector <GLuint> Texture;
public:
	//=================================================================================================================
	void AddEntry( GLuint entry ) {
		Texture.push_back( entry );
	}
	
	//=================================================================================================================
	void RemoveEntry( GLuint entry ) {
		//remove an entry from the registry when it needs deleting
		for ( unsigned long REInt = 0; REInt < Texture.size(); REInt++ ) {
			if ( Texture[ REInt ] == entry ) Texture.erase( Texture.begin()+REInt );
		}
	}
	
	//=================================================================================================================
	void ShutdownRegistry( void ) {
		//this is called at the end of the application to release ALL textures
		for ( unsigned long REInt = 0; REInt < Texture.size(); REInt ++ ) {
			glDeleteTextures( 1, &Texture[ REInt ] );
		}
		Texture.clear();
	}
};

TRegistryTextureClass	TTextureRegistry;
