/*
 *  TombstoneVariables.h
 *  Tombstone Demo
 *
 *  Created by EdzUp on 23/05/2010.
 *  Copyright 2010 Graveyard Dogs. All rights reserved.
 *
 */
#define		TOMBSTONE_VERSION	"0.1Ng"

#if defined( __APPLE__ )					//Apple platform uses OpenGL ES
#if TARGET_OS_IPHONE || TARGET_OS_SIMULATOR
#import <UIKit/UIKit.h>
#import <OpenGLES/ES1/gl.h>
#import "TombstoneiPhoneFunctions.h"
#else
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>
#import <GLUT/GLUT.h>
#import "TombstoneOSXFunctions.h"
#endif
#endif

#if defined( __LINUX__ )
#include <GL/glut.h>    // Header File For The GLUT Library 
#include <GL/gl.h>	// Header File For The OpenGL32 Library
#include <GL/glu.h>	// Header File For The GLu32 Library
#include <unistd.h>     // Header File For sleeping.
#import "TombstoneLinuxFunctions.h"		//all linux declarations for the entire engine
#endif

#if defined( __WINDOWS__ )
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library#import <windows.h>						//on windows platform import the Windows headers
#import "TombstoneWindowsFunctions.h"	//windows functions
#endif

//check on defines for TRUE, FALSE, YES and NO :)
#ifndef TRUE
	#define TRUE 1
#endif
#ifndef FALSE
	#define FALSE -1
#endif

#ifndef YES
	#define YES	1
#endif
#ifndef NO
	#define NO -1
#endif
#define ESCAPE 27

#include <fstream>
#include <iostream>
#include <string>
#include <list>

using namespace std;

GLfloat specularity[ 4 ];
GLfloat GLRed			= 1.0;
GLfloat GLGreen			= 1.0;
GLfloat GLBlue			= 1.0;
GLfloat GLAlpha			= 1.0;
GLfloat imageDrawAngle;
GLfloat LineWidth		= 1.0;

//======================================================================================================
typedef enum {
	kTexture2DPixelFormat_Automatic = 0,
	kTexture2DPixelFormat_RGBA8888,
	kTexture2DPixelFormat_RGB565,
	kTexture2DPixelFormat_A8,
} Texture2DPixelFormat;

#define kMaxTextureSize		1024			//maximum texture size for this system
#define FPS					30				//maximum frames per second required
#define RAD_DEGREE			0.01745
#define MAX_TEXTURES		1024			//maximum texture size
#define DEG_TO_RAD			0.017453293f
#define RAD_TO_DEGBB		57.2957795130823208767981548141052
#define DEG_TO_RADBB		0.0174532925199432957692369076848861

#define PI					(3.14159265358979323846)
#define RADIANS_PER_DEGREE	(PI/180.0)
#define DEGREES_TO_RADIANS(num) ((num) * RADIANS_PER_DEGREE)

#define alignTopLeft		0				//alignment system
#define alignTopCenter		1
#define alignTopRight		2
#define alignLeft			3
#define alignCenter			4
#define alignRight			5
#define alignBottomLeft		6
#define alignBottomCenter	7
#define alignBottomRight	8

#define TOMBSTONEALIGNMENT_VERTICAL		1
#define TOMBSTONEALIGNMENT_HORIZONTAL	2

#define FADE_NOFADE						0
#define FADE_FROMTOP					1
#define	FADE_FROMBOTTOM					2
#define FADE_TOMIDDLE					3
#define FADE_FROMMIDDLE					4
#define FADE_RANDOM						5

#define VERTEX_SPECIFIED				0					//only change the one specified to target
#define VERTEX_ALL						1					//change all vertices at that specific location

// Constants -----------------------------------------------------------------

string TombstoneWindowTitle = "Tombstone engine window";
long TombstoneWidth		= 400;
long TombstoneHeight	= 300;
long TombstoneDepth		= 32;
long TombstoneAlignment = TOMBSTONEALIGNMENT_VERTICAL;
short TombstoneFullScreen = FALSE;
long texturesBound		= 0;

float TombstoneOffsetX	= 0.0;
float TombstoneOffsetY	= 0.0;
float TombstoneOffsetZ	= 0.0;

short TombstoneBackfaceCulling		= FALSE;

/*static GLfloat returnFraction( GLfloat val ) {
	//this will return the fraction of 255 in OpenGL friendly values so 128 will be 0.5
	return( ( 1.0 / 255 ) *val );
}*/
